import { BULLET_SIZE, FONT_SIZE, TOT_SHOTS } from './Constants.js';
import bullet from '../data/bullet.png';


class ScoreDisplay {
  constructor(initialBullets) {
    this.img = null;
    this.shotLeft = initialBullets;
    this.score = 0;

    loadImage(bullet, (PImage) => {
      this.img = PImage;
    });
  }

  draw() {
    // score
    textFont('Arial');
    textSize(25);
    fill(255, 0, 0);
    textAlign(LEFT, TOP);
    text(`Score: ${this.score}`, 10, 10);

    // bullets
    if (!this.img) return;
    const bulletSpacing = 20;
    const marginRight = 10;
    const bulletsWidth = this.shotLeft * bulletSpacing;
    let startX = width - bulletsWidth - marginRight;
    let y = 10;

    for (let i = 0; i < this.shotLeft; i++) {
      image(this.img, startX + i * bulletSpacing, y, BULLET_SIZE, BULLET_SIZE);
    }

  }

  resetScore() {
    this.score = 0;
  }

  addScore(scoreToAdd) {
    this.score += scoreToAdd;
  }

  setBullets(numBullets) {
    this.shotLeft = numBullets;
  }

  update(source, ...others) {
    if (source === 'gun') {
      const [, , remainingShots] = others;
      this.setBullets(remainingShots);
    } else if (source === 'target-hit') {
      const [points] = others;
      this.addScore(points);
    }
  }
}

export { ScoreDisplay };
